//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                e-PSI@MultiSET.mq4 |
//|                                                      Copyright  2011-14, TarasBY |
//|                                                                taras_bulba@tut.by |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-14, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
#property version   "2.00"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,    .    |
//|         .                            |
//|         ,    - |
//| .                                                             |
//|     ,     ,    |
//|     Skype: TarasBY  e-mail.                          |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a expert or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a expert.    |
//|   For all matters relating to the work of the expert, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIII================================IIIIIIIIIIIIIIIIIIIII+
enum ENUM_PRICE
{
    PRICE_0 = 0,          // Bid or Ask
    PRICE_1,              // Open[0]
    PRICE_2,              // Close[1]
    PRICE_3,              // Close[0]
    PRICE_4,              // Open[0]  NewBarInPeriod
    PRICE_5,              // High[1]  Low[1]  NewBarInPeriod
    PRICE_6,              // High[0]  Low[0]  ControlPeriod
    PRICE_7               // High[1]  Low[1]  M1
};
enum ENUM_PERIOD
{
    PERIOD_NO  = -1,      // AllTick
    PERIOD_0   = 0,       // Period()
    PERIOD_m1  = 1,       // M1
    PERIOD_m5  = 5,       // M5
    PERIOD_m15 = 15,      // M15
    PERIOD_m30 = 30,      // M30
    PERIOD_h1  = 60,      // H1
    PERIOD_h4  = 240,     // H4
    PERIOD_d1  = 1440,    // D1
    PERIOD_w1  = 10080,   // W1
    PERIOD_mn1 = 43200    // MN1
};
enum ENUM_LOTS_WAY_CHOICE
{
     Fixed,               // Fixed
     Percent              // Procent from MeansType
};
enum ENUM_MEANS_TYPE
{
     Balance = 1,         // Balance
     Equity,              // Equity
     FreeMargin,          // FreeMargin
     Risk_Depo,           // RiskDepo
     BB_plus_Pribul       // BaseBalance + Pribul
};
enum ENUM_HOUR
{
     HOUR_00 = 0,         // 00
     HOUR_01,             // 01
     HOUR_02,             // 02
     HOUR_03,             // 03
     HOUR_04,             // 04
     HOUR_05,             // 05
     HOUR_06,             // 06
     HOUR_07,             // 07
     HOUR_08,             // 08
     HOUR_09,             // 09
     HOUR_10,             // 10
     HOUR_11,             // 11
     HOUR_12,             // 12
     HOUR_13,             // 13
     HOUR_14,             // 14
     HOUR_15,             // 15
     HOUR_16,             // 16
     HOUR_17,             // 17
     HOUR_18,             // 18
     HOUR_19,             // 19
     HOUR_20,             // 20
     HOUR_21,             // 21
     HOUR_22,             // 22
     HOUR_23,             // 23
     HOUR_24              // 24
};
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
sinput string SETUP_Expert          = "==========    ==========";
input  ushort MG                       = 707;              // Magic
input  ENUM_PERIOD NewBarInPeriod      = 1;                // >= 0 -      , -1 -    
input  ENUM_PRICE Variant_TradePrice   = PRICE_4;          //  ,     
// 0 - Bid\Ask ("  ") -       
// 1 - Open[0] -   ( )
// 2 - Close[1] - ( )
// 3 - Close[0] - "  "
// 4 - Price[0] = iOpen (gs_Symbol, NewBarInPeriod, 0); Price[1] = Price[0] + spread
// 5 - Price[0] = iHigh (gs_Symbol, NewBarInPeriod, 1); Price[1] = iLow (gs_Symbol, NewBarInPeriod, 1)
// 6 - Price[0] = iHigh (gs_Symbol, ControlPeriod, 0); Price[1] = iLow (gs_Symbol, ControlPeriod, 0)
// 7 - Price[0] = iHigh (gs_Symbol, 1, 1); Price[1] = iLow (gs_Symbol, 1, 1)
input  ENUM_TIMEFRAMES ControlPeriod   = PERIOD_H1;        // ,    
sinput string SETUP_RulesSend       = "---------------- RULES`s SEND -----------------";
extern double TakeProfit               = 20;               //     ,  ,   
extern double StopLoss                 = 200;              //     ,   ,   
input  bool   Use_Prioritity           = TRUE;             //       
sinput string LifeStart_minList        = "18,10,9,7,12,10,6";    //      ,    ,   
extern ushort Dopusk                   = 2;                //   
sinput string MIN_DistanceList         = "14,19,18,10,18,19,16"; //            
sinput string SETUP_RulesClose      = "---------------- RULES`s CLOSE ----------------";
sinput string Life_barsList            = "1,10,2,10,2,8,10";     //    
extern ushort ProfitMIN                = 3;                //    .  
sinput string SETUP_Trailling       = "================== TRAILING ===================";
extern bool   VirtualTrail_ON          = TRUE;             //   
sinput string TrailingStopList         = "11,12,14,5,11,12,10";  //  -,    
sinput string Setup_Lots            = "========     ========";
input  bool   UseMM                    = TRUE;             //   
input  ENUM_LOTS_WAY_CHOICE LotsWayChoice = Percent;       //    :
input  ENUM_MEANS_TYPE MeansType       = Equity;           //       :
extern double Order_Lots               = 0.1;              //   
extern uchar  LotsPercent              = 7;                //   MeansType
extern double MinLot                   = 0.01;             //    
extern double MaxLot                   = 5.0;              //     
sinput string Setup_MM_DEPO         = "---------------- CONTROL DEPO -----------------";
extern double BaseBalance		            = 300;              //  
extern double RiskDepo                 = 150;              //  Depo   ,   
input  uchar  MINMarginPercent         = 30;               //           
input  uchar  MAXZagruzkaDepoPercent   = 50;               //   Depo      
input  uchar  MAXOtkatDepoPercent      = 30;               //      Depo ( )  
input  uchar  MAXLossDepoPercent       = 30;               //     Depo ( )   
input  bool   FULL_Control_ON          = False;            //         (   MAGIC)
sinput string Setup_Services        = "=================== SERVICES ==================";
extern bool   PrintCom                 = TRUE;             //  .
extern bool   ShowCommentInChart       = TRUE;             //    .
extern bool   SoundAlert               = FALSE;            // 
extern uchar  Slippage                 = 2;                //     
sinput string WorkSheduller         = "=============    ============";
input  bool   TimeControl              = True;
sinput string BadDay                   = "0";              //      ( ",")
sinput string BadTime                  = "0";              //     ( ",")
input  ENUM_HOUR Open_HourTrade        = 2;                //  
input  ENUM_HOUR Close_HourTrade       = 20;               //  
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gda_Price[2],               //   
              // gda_Price[0] - Bid
              // gda_Price[1] - Ask
              gd_MinEquity,               //       
              gd_MinEquityPercent,        //      
              gd_MinMargin,               //    ,    
              gd_MinMarginPercent,        //    ,      
              gd_MaxZalog,                //      
              gd_MaxZalogPercent,         //     
              gd_BeginBalance,            //   
              gd_MaxLOSS,                 //     
              gd_MaxLOSSPercent,          //       
              gd_curLOSSPercent,          //       
              gd_curMAXOtkatDepoPercent,  //     gd_MAXBalance
              gd_MAXBalance,              //    (   MAXOtkatDepoPercent)
              gd_Balance, gd_Equity, gd_FreeMargin, gd_Margin,
              gd_TP, gd_SL, gd_Trail, gd_MIN_Distance, gd_step, gd_RealSPREAD,
              gda_TrailingStop[], gda_MIN_Distance[], gda_AvarageCandle[2], gda_TrailStop[],
              gda_BaseBalance[], gda_Profit[], gda_Pribul[], gd_ProfitALL,
              gd_LOTSTEP, gd_MAXLOT, gd_MINLOT, gd_dopusk,
              gd_BaseBalance, gd_PribulALL, LotsMM;
int           gi_Decimal = 1, gi_curOrdersInSeries, gi_HistoryOrders, cur_Life_min, gi_dig,
              gi_MyOrders, gia_BadTime[], gia_MG[], cnt_MG = 0, gia_LifeStart[], gia_BadDay[], ind_ERR,
              gia_HistoryOrders[], gia_MyOrders[], gia_Life_bars[], gia_Priority[], gia_CommTime[6],
              gi_CTRL_TF;
ENUM_TIMEFRAMES gi_NewBarInPeriod, gi_ControlPeriod;
string        gs_Symbol, gs_NameGV,
              gsa_Comment[6],
              // gsa_Comment[0]-  MM
              // gsa_Comment[1]-  TimeControl
              // gsa_Comment[2]-    
              // gsa_Comment[3]-    
              // gsa_Comment[4]-    
              // gsa_Comment[5]- 
              ExpertName,
              gs_Info,                   //         
              gs_sign;                   //     
bool          gb_Pause = false, PrintStatistic = false,
              gb_TimePause = false,      //      
              RealTrade = true,          //  " "  
              gb_Trade = true,
              gb_VirualTrade = false,
              gb_first = true,           //   
              gb_InfoPrint = false;
datetime      gdt_NewBar, gdt_NewBarControl, gdt_NewBarH1, 
              gdt_BeginBar_H1, gdt_curTime, gdt_LastBalanceTime,
              gdt_BeginTrade;            //   ""  
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
#include      <stdlib.mqh>
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void OnInit()
{
    int    li_size, li_int;
    string ls_txt = "", ls_tmp = "";
//----
    gs_Symbol = Symbol();
    gi_dig = LotDecimal();
    //----   
    fCheck_Decimal();
    gs_NameGV = StringConcatenate ("MultiSET[", MG, "]");
    ExpertName = StringConcatenate (WindowExpertName(), ":  ", fGet_NameTF (Period()), "_", gs_Symbol);
    gd_MAXLOT = MarketInfo (gs_Symbol, MODE_MAXLOT);
    gd_MINLOT = MarketInfo (gs_Symbol, MODE_MINLOT);
    gd_LOTSTEP = MarketInfo (gs_Symbol, MODE_LOTSTEP);
    if (NewBarInPeriod == 0) {gi_NewBarInPeriod = (ENUM_TIMEFRAMES) Period();} else gi_NewBarInPeriod = (ENUM_TIMEFRAMES) NewBarInPeriod;
    if (ControlPeriod == 0) {gi_ControlPeriod = (ENUM_TIMEFRAMES) Period();} else gi_ControlPeriod = ControlPeriod;
    gdt_NewBar = iTime (gs_Symbol, gi_NewBarInPeriod, 1);
    gi_CTRL_TF = gi_NewBarInPeriod;
    InitializeArray_STR (gsa_Comment);
    //----   ""    (gsa_Comment)
    ind_ERR = ArraySize (gsa_Comment) - 1;
    //----    
    gs_sign = IIFs ((AccountCurrency() == "USD"), "$", IIFs ((AccountCurrency() == "EUR"), "", "RUB"));
    //----        
    fGet_IsStatusTrade (PrintCom, ShowCommentInChart, gb_InfoPrint, SoundAlert, RealTrade);
    //----  "  "
    if (TimeControl)
    {
        //----  ""   
        li_size = fStringToArray (BadDay, gia_BadDay);
        //----  ""   
        li_size = fStringToArray (BadTime, gia_BadTime);
    }
    int lia_IND[4];
    bool lb_CondON = false;
    //----     
    for (li_int = 0; li_int < 4; li_int++)
    {
        ls_tmp = "";
        switch (li_int)
        {
            case 0:
                lia_IND[li_int] = fStringToArray (TrailingStopList, gda_TrailingStop, True);
                cnt_MG = lia_IND[li_int];
                break;
            case 1: lia_IND[li_int] = fStringToArray (LifeStart_minList, gia_LifeStart); break;
            case 2: lia_IND[li_int] = fStringToArray (MIN_DistanceList, gda_MIN_Distance, True); break;
            case 3: lia_IND[li_int] = fStringToArray (Life_barsList, gia_Life_bars); break;
        }
        //----    
        if (cnt_MG != lia_IND[li_int]) {cnt_MG = MathMax (cnt_MG, lia_IND[li_int]); lb_CondON = true;}
        for (int li_IND = 0; li_IND < lia_IND[li_int]; li_IND++)
        {
            switch (li_int)
            {
                case 0: ls_tmp = StringConcatenate (ls_tmp, "TrailingStop[", li_IND, "] = ", DoubleToStr (gda_TrailingStop[li_IND], Digits), "; "); break;
                case 1: ls_tmp = StringConcatenate (ls_tmp, "LifeStart[", li_IND, "] = ", gia_LifeStart[li_IND], "; "); break;
                case 2: ls_tmp = StringConcatenate (ls_tmp, "MIN Distance[", li_IND, "] = ", DoubleToStr (gda_MIN_Distance[li_IND], Digits), "; "); break;
                case 3: ls_tmp = StringConcatenate (ls_tmp, "Life bars[", li_IND, "] = ", gia_Life_bars[li_IND], "; "); break;
            }
        }
        Print (ls_tmp);
    }
    //----    
    if (lb_CondON)
    {
        bool lb_bool;
        for (li_int = 0; li_int < 4; li_int++)
        {
            ls_tmp = "";
            lb_bool = true;
            li_size = lia_IND[li_int];
            if (li_size == cnt_MG) continue;
            
            for (li_IND = 0; li_IND < cnt_MG; li_IND++)
            {
                if (li_IND < li_size) continue;
                //----      
                switch (li_int)
                {
                    case 0:
                        if (lb_bool) {ArrayResize (gda_TrailingStop, cnt_MG); lb_bool = false;}
                        gda_TrailingStop[li_IND] = gda_TrailingStop[li_size-1];
                        ls_tmp = StringConcatenate (ls_tmp, "TrailingStop[", li_IND, "] = ", DoubleToStr (gda_TrailingStop[li_IND], Digits), "; ");
                        break;
                    case 1:
                        if (lb_bool) {ArrayResize (gia_LifeStart, cnt_MG); lb_bool = false;}
                        gia_LifeStart[li_IND] = gia_LifeStart[li_size-1];
                        ls_tmp = StringConcatenate (ls_tmp, "LifeStart[", li_IND, "] = ", gia_LifeStart[li_IND], "; ");
                        break;
                    case 2:
                        if (lb_bool) {ArrayResize (gda_MIN_Distance, cnt_MG); lb_bool = false;}
                        gda_MIN_Distance[li_IND] = gda_MIN_Distance[li_size-1];
                        ls_tmp = StringConcatenate (ls_tmp, "MIN Distance[", li_IND, "] = ", DoubleToStr (gda_MIN_Distance[li_IND], Digits), "; ");
                        break;
                    case 3:
                        if (lb_bool) {ArrayResize (gia_Life_bars, cnt_MG); lb_bool = false;}
                        gia_Life_bars[li_IND] = gia_Life_bars[li_size-1];
                        ls_tmp = StringConcatenate (ls_tmp, "Life bars[", li_IND, "] = ", gia_Life_bars[li_IND], "; ");
                        break;
                }
            }
            Print (ls_tmp);
        }
    }
    //----   
    ArrayResize (gia_MG, cnt_MG);
    //----  
    ArrayResize (gia_MyOrders, cnt_MG);
    ArrayResize (gia_HistoryOrders, cnt_MG);
    ArrayResize (gia_Priority, cnt_MG);
    ArrayResize (gda_Pribul, cnt_MG);
    ArrayResize (gda_Profit, cnt_MG);
    ArrayResize (gda_BaseBalance, cnt_MG);
    //----    
    for (li_int = 0; li_int < cnt_MG; li_int++)
    {gia_MG[li_int] = MG + li_int;}
    //----   
    fGet_Statistic();
    //----      
    if (gdt_BeginTrade == 0)
    {gdt_BeginTrade = gdt_curTime;}
    //----   
    Order_Lots = fLotsNormalize (Order_Lots);
    LotsMM = fGet_SizeLot (ls_txt, Order_Lots, OP_BUY, gd_BaseBalance, gia_MG[0], gi_curOrdersInSeries, MINMarginPercent, MAXZagruzkaDepoPercent, gs_NameGV);
    fPrintAndShowComment (ls_txt, ShowCommentInChart, PrintCom, gsa_Comment, 0);
	   Print (" = ", AccountLeverage(), " | MIN Lot = ", DSDig (gd_MINLOT), " | MAX Lot = ", DSDig (gd_MAXLOT), " | Lot = ", DSDig (LotsMM), " | SPREAD = ", MarketInfo (gs_Symbol, MODE_SPREAD));
    //----   
    fGetLastError (gsa_Comment, "init()", ind_ERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void OnDeinit (const int reason)
{
//----
    //----    
    if (ShowCommentInChart)
    {
        //----  
        fGet_Statistic();
        fCommentInChart (gsa_Comment, gia_CommTime);
    }
    Sleep (500);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void OnTick()
{
    //----    "" 
    if (fSet_Continue()) return;
//----
    gdt_BeginBar_H1 = iTime (gs_Symbol, 60, 0);
    //----     (Bad Hour)
    if (gdt_NewBarH1 == gdt_BeginBar_H1) {return;}
    datetime ldt_BeginBarControl = iTime (gs_Symbol, gi_ControlPeriod, 0);
    //----  -      
    if (gdt_NewBarControl == ldt_BeginBarControl) {return;}
//----
    int    li_pos, li_total, li_Ticket, li_MG,
           li_tmp_HistoryOrders, err = GetLastError();
    string ls_txt = "";
    static double lda_MIN_Distance[], lda_Trail[];
//----
    //----   
    if (gb_first)
    {
        ArrayResize (lda_MIN_Distance, cnt_MG);
        ArrayResize (lda_Trail, cnt_MG);
    }
    gi_MyOrders = fMyPositions (gda_Profit, gia_MyOrders, gia_MG);
    //----  
    fGet_Statistic();
    //----    
    if (ShowCommentInChart) {fCommentInChart (gsa_Comment, gia_CommTime);}
    //----      ( NewBarInPeriod >= 0)
    if (gi_NewBarInPeriod >= 0)
    {
        if (gi_MyOrders == 0)
        {
            if (gdt_NewBar == iTime (gs_Symbol, gi_NewBarInPeriod, 0)) {return;}
            gdt_NewBar = iTime (gs_Symbol, gi_NewBarInPeriod, 0);
            //----        
            if (gdt_NewBar == ldt_BeginBarControl) {return;}
        }
    }
    //----    
    if (IsTradeTime (Open_HourTrade, Close_HourTrade))
    {
        gb_TimePause = IsBadTime (gia_BadDay, gia_BadTime);
        gb_Pause = gb_TimePause;
    }
    else {gb_Pause = true;}
    if (gi_MyOrders == 0)
    {
        //----  ,    
        if (gb_Pause)
        {
            if (gb_TimePause)
            {
                if (gdt_NewBarH1 != gdt_BeginBar_H1)
                gdt_NewBarH1 = gdt_BeginBar_H1;
            }
            return;
        }
    }
    int li_extrem = -1;
    //----     -    
    if (iHigh (gs_Symbol, gi_ControlPeriod, 0) - iOpen (gs_Symbol, gi_ControlPeriod, 0) <= gd_dopusk)
    {li_extrem = 0;}
    else if (iOpen (gs_Symbol, gi_ControlPeriod, 0) - iLow (gs_Symbol, gi_ControlPeriod, 0) <= gd_dopusk)
    {li_extrem = 1;}
    else
    {
        //----     -    BarControl 
        if (gi_MyOrders == 0)
        {gdt_NewBarControl = ldt_BeginBarControl; return;}
        gb_Pause = true;
    }
    //----  ,     
    fGet_MineTradePrice (Variant_TradePrice, gda_Price);
    //----   ,    ControlPeriod 
    cur_Life_min = iBarShift (gs_Symbol, PERIOD_M1, ldt_BeginBarControl);
    //----    (gda_AvarageCandle[0])  (gda_AvarageCandle[1])    
    fGet_AverageCandle (gda_AvarageCandle, 1, gs_Symbol, gi_ControlPeriod);
    //----   
    if (!gb_Pause)
    {
        int    NO_orders = 0, li_cmd, li_ind, li_ORD;
        double ld_Price, ld_TP, ld_PriceBar = iOpen (gs_Symbol, gi_ControlPeriod, 0);
        bool   lb_NotMoney = false;
        string lsa_ord[] = {"buy","sell"};
        color  lca_color[] = {Blue,Red};
        //----       
        for (int li_PR = 0; li_PR < cnt_MG; li_PR++)
        {
            //----    
            if (Use_Prioritity && !gb_first) {li_MG = gia_Priority[li_PR];} else {li_MG = li_PR;}
            //----     
            if (gia_MyOrders[li_MG] == 0)
            {
                //----        
                fCalculate_Pribul (li_tmp_HistoryOrders, gia_MG[li_MG], ldt_BeginBarControl);
                if (li_tmp_HistoryOrders > 0 || gdt_NewBarControl == ldt_BeginBarControl) {continue;}
                if (cur_Life_min <= gia_LifeStart[li_MG])
                {
                    for (li_ORD = 0; li_ORD < 2; li_ORD++)
                    {
                        //----     
                        if (li_extrem == li_ORD)
                        {
                            //----   MIN_Distance
                            if (gda_MIN_Distance[li_MG] < 0)
                            {
                                if (gda_MIN_Distance[li_MG] == -1.0)
                                {lda_MIN_Distance[li_MG] = NormalizeDouble (gda_AvarageCandle[0], Digits);}
                                else if (gda_MIN_Distance[li_MG] == -2.0)
                                {lda_MIN_Distance[li_MG] = NormalizeDouble (gda_AvarageCandle[1] / 2.0, Digits);}
                            }
                            else {lda_MIN_Distance[li_MG] = gda_MIN_Distance[li_MG];}
                            if (li_ORD == 0) {li_cmd = 1; li_ind = 1;} else {li_cmd = -1; li_ind = 0;}
                            //----      
                            if (li_cmd * (ld_PriceBar - gda_Price[li_ind]) >= lda_MIN_Distance[li_MG]
                            //----     
                            && li_cmd * (ld_PriceBar - gda_Price[li_ind]) <= lda_MIN_Distance[li_MG] * 2.0)
                            {
                                //----   
                                LotsMM = fGet_SizeLot (ls_txt, Order_Lots, li_ORD, gda_BaseBalance[li_MG], gia_MG[li_MG], gi_curOrdersInSeries, MINMarginPercent, MAXZagruzkaDepoPercent, gs_NameGV);
                                fPrintAndShowComment (ls_txt, ShowCommentInChart, PrintCom, gsa_Comment, 0);
                                //----     -  
                                if (LotsMM > 0)
                                {
                                    li_Ticket = 0;
                                    ld_Price = NormalizeDouble (fGet_TradePrice (li_ind, RealTrade, gs_Symbol), Digits);
                                    ld_TP = NormalizeDouble (ld_Price + li_cmd * MathMax (gd_TP, MarketInfo (gs_Symbol, MODE_STOPLEVEL) * Point), Digits);
                                    li_Ticket = OrderSend (gs_Symbol, li_ORD, LotsMM, ld_Price, Slippage, NormalizeDouble (ld_Price - li_cmd * gd_SL, Digits), ld_TP, lsa_ord[li_ORD], gia_MG[li_MG], 0, lca_color[li_ORD]);  
                                    if (li_Ticket > 0)
                                    {
                                        if (!gb_VirualTrade)
                                        {
                                            if (!OrderSelect (li_Ticket, SELECT_BY_TICKET)) continue;
                                            OrderPrint();
                                            ls_txt = fPrepareComment (StringConcatenate ("#", li_Ticket, "[", gia_MG[li_MG], "/", li_MG, "] ", fGet_NameOP (OrderType()), " at ", DoubleToStr (OrderOpenPrice(), Digits),
                                            "; MIN Distance = ", lda_MIN_Distance[li_MG] / Point), gb_InfoPrint);
                                            fPrintAndShowComment (ls_txt, ShowCommentInChart, PrintCom, gsa_Comment, 3);
                                            PrintStatistic = true;
                                        }
                                    }
                                    break;
                                }
                                //----        
                                else {lb_NotMoney = true;}
                            }
                        }
                    }
                }
                else
                {
                    //----   , ""   
                    NO_orders++;
                    if (NO_orders == cnt_MG - 1)
                    {gdt_NewBarControl = ldt_BeginBarControl; return;}
                    continue;
                }
            }
            //----   "" - 
            if (lb_NotMoney) {break;}
        }
    }
    if (gi_MyOrders > 0)
    {
        double ld_new_SL, ld_SL, ld_Profit;
        int    li_Order_Bar, li_Life_bars;
        bool   lb_profit, lb_life, lb_loss, lb_trail;
        string ls_Name;
        color  lca_close[] = {Green,Magenta};
        li_total = OrdersTotal() - 1; 
        //----         
        fGet_MineTradePrice (0, gda_Price);
        //----    
        if (ProfitMIN == 0) {ProfitMIN = gd_RealSPREAD / Point;}
        for (li_pos = li_total; li_pos >= 0; li_pos--)
        {
            if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) {continue;}
            li_MG = fCheck_MyMagic (OrderMagicNumber(), gia_MG);
            if (li_MG >= 0 && OrderSymbol() == gs_Symbol)
            {
                if (OrderType() <= OP_SELL)
                {
                    ld_Profit = OrderProfit() + OrderSwap() + OrderCommission();
                    li_Ticket = OrderTicket();
                    lb_profit = false; lb_life = false; lb_trail = false; lb_loss = false;
                    //----   
                    if (gda_TrailingStop[li_MG] < 0.0)
                    {lda_Trail[li_MG] = NormalizeDouble (lda_MIN_Distance[li_MG] / 3.0, Digits);}
                    else {lda_Trail[li_MG] = gda_TrailingStop[li_MG];}
                    //----   ""    ( )
                    li_Order_Bar = iBarShift (gs_Symbol, gi_ControlPeriod, OrderOpenTime());
                    if (gia_Life_bars[li_MG] > 0) {li_Life_bars = gia_Life_bars[li_MG] - li_Order_Bar;}
                    //----       
                    else
                    {li_Life_bars = 1440 / gi_ControlPeriod - iBarShift (gs_Symbol, gi_ControlPeriod, iTime (gs_Symbol, PERIOD_D1, iBarShift (gs_Symbol, PERIOD_D1, OrderOpenTime())));}
                    lb_life = (li_Life_bars <= 0);
                    //----  SL
                    if (VirtualTrail_ON)
                    {
                        ls_Name = StringConcatenate (li_Ticket, "_#SL");
                        if (!GlobalVariableCheck (ls_Name)) {ld_SL = OrderStopLoss();}
                        else {ld_SL = GlobalVariableGet (ls_Name);}
                    }
                    else {ld_SL = OrderStopLoss();}
                    ld_PriceBar = iOpen (gs_Symbol, gi_ControlPeriod, li_Order_Bar);
                    for (li_ORD = 0; li_ORD < 2; li_ORD++)
                    {
                        if (OrderType() == li_ORD)
                        {
                            if (li_ORD == 0) {li_cmd = 1;} else {li_cmd = -1;}
                            //----       
                            if (!lb_life)
                            {
                                //----    
                                lb_profit = (li_cmd * (gda_Price[li_ORD] - ld_PriceBar) >= 0.0);
                                //----     
                                lb_loss = (li_cmd * (OrderOpenPrice() - gda_Price[li_ORD]) > MathMax (gda_AvarageCandle[1], lda_MIN_Distance[li_MG]) * 2.0 && li_Order_Bar == 0);
                                //----     
                                lb_trail = (VirtualTrail_ON                     //   
                                && li_cmd * (ld_SL - gda_Price[li_ORD]) >= 0.0  //   
                                && ld_Profit > ProfitMIN * fGet_PipsValue()     //    
                                && gda_TrailingStop[li_MG] != 0.0);             //    
                            }
                            //---- 
                            if (lb_profit || lb_life || lb_trail || lb_loss)
                            {
                                ld_Price = NormalizeDouble (fGet_TradePrice (li_ORD, RealTrade, gs_Symbol), Digits);
                                if (OrderClose (li_Ticket, OrderLots(), ld_Price, Slippage, lca_close[li_ORD]))
                                {
                                    if (!gb_VirualTrade)
                                    {
                                        if (!OrderSelect (li_Ticket, SELECT_BY_TICKET)) continue;
                                        int li_pips = li_cmd * (OrderClosePrice() - OrderOpenPrice()) / Point;
                                        ls_txt = fPrepareComment (StringConcatenate ("#", li_Ticket, "[", gia_MG[li_MG], "/", li_MG, "] STOP ",
                                        IIFs (lb_profit, StringConcatenate ("Profit  [Dist:", lda_MIN_Distance[li_MG] / Point, " | PIP`s:", li_pips, " | Life: ", li_Order_Bar, "]"),
                                        IIFs (lb_loss, StringConcatenate ("LOSS  [Dist:", lda_MIN_Distance[li_MG] / Point, " | PIP`s:", li_pips, " | Life: ", li_Order_Bar, "]"),
                                        IIFs (lb_life, StringConcatenate ("Life  [Limit:", gia_Life_bars[li_MG], " | cur:", li_Order_Bar, "]"),
                                        IIFs (lb_trail, StringConcatenate ("Trail  [Tr:", lda_Trail[li_MG] / Point, " | ProfitMIN: ", gs_sign, DSDig (ProfitMIN * fGet_PipsValue()), " | Life: ", li_Order_Bar, "]"), "")))),
                                        " Profit: ", gs_sign, fSplitField (DSDig (ld_Profit))), gb_InfoPrint);
                                        fPrintAndShowComment (ls_txt, ShowCommentInChart, PrintCom, gsa_Comment, 4);
                                    }
                                    break;
                                }
                            }
                            //---- -
                            if (gda_TrailingStop[li_MG] != 0.0)  
                            {
                                if (li_cmd * (gda_Price[li_ORD] - OrderOpenPrice()) > lda_Trail[li_MG])
                                {
                                    ld_new_SL = NormalizeDouble (gda_Price[li_ORD] - li_cmd * lda_Trail[li_MG], Digits);
                                    if (li_cmd * (ld_new_SL - ld_SL) > gd_step
                                    || ld_SL == 0.0)
                                    {
                                        if (!VirtualTrail_ON)
                                        {
                                            if (OrderModify (li_Ticket, OrderOpenPrice(), ld_new_SL, OrderTakeProfit(), 0, Gold))
                                            {break;}
                                        }
                                        else {GlobalVariableSet (ls_Name, ld_new_SL);}
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    gb_first = false;
    //----   
    fGetLastError (gsa_Comment, "start()", ind_ERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|             ""                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (
    double& ar_Profit[],
    int& ar_MyOrders[],
    int& ar_Magic[])
//+...................................................................................+
{
    int    li_total = OrdersTotal(), li_Ord = 0, li_ind_MG;
    double ld_Profit;
//----
    ArrayInitialize (ar_Profit, 0.0);
    ArrayInitialize (ar_MyOrders, 0);
    gd_ProfitALL = 0.0;
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != gs_Symbol) continue;
        li_ind_MG = fCheck_MyMagic (OrderMagicNumber(), ar_Magic);
        if (li_ind_MG < 0) continue;
        if (OrderType() > OP_SELL) continue;
        ld_Profit = OrderProfit() + OrderSwap() + OrderCommission();
        ar_Profit[li_ind_MG] = ld_Profit;
        gd_ProfitALL += ld_Profit;
        ar_MyOrders[li_ind_MG]++;
        li_Ord++;
    }
//----
    return (li_Ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_AverageCandle (
    double& fda_AvarageCandle[],     //  
    int fi_Day,                      //   
    string fs_Symbol,                // 
    int fi_Period = 0)               // 
//+...................................................................................+
{
    static datetime ldt_NewDay;
    if (ldt_NewDay == iTime (fs_Symbol, fi_Period, 0)) {return;}
    ldt_NewDay = iTime (fs_Symbol, fi_Period, 0);
//----
    double ld_OPEN, ld_CLOSE, ld_HIGH, ld_LOW;
    datetime ldt_Begin = iTime (fs_Symbol, PERIOD_D1, fi_Day);
    int      li_cnt_Bar = iBarShift (fs_Symbol, fi_Period, ldt_Begin);
//----
    ArrayInitialize (fda_AvarageCandle, 0.0);
    for (int li_BAR = 1; li_BAR < li_cnt_Bar; li_BAR++)
    {
        //----    
        ld_OPEN = iOpen (fs_Symbol, fi_Period, li_BAR);
        ld_CLOSE = iClose (fs_Symbol, fi_Period, li_BAR);
        fda_AvarageCandle[0] += MathAbs (ld_OPEN - ld_CLOSE);
        //----   
        ld_HIGH = iHigh (fs_Symbol, fi_Period, li_BAR);
        ld_LOW = iLow (fs_Symbol, fi_Period, li_BAR);
        fda_AvarageCandle[1] += (ld_HIGH - ld_LOW);
    }
    fda_AvarageCandle[0] /= (li_cnt_Bar - 1);
    fda_AvarageCandle[1] /= (li_cnt_Bar - 1);
//----
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|   :      .                             |
//+-----------------------------------------------------------------------------------+
//|  :                                                                       |
//|    iPrice : 0 - Bid; 1 - Ask                                                      |
//|    isTrade:    \                        |
//|    Symb   :                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_TradePrice (
    int iPrice,
    bool isTrade,
    string Symb = "")
//+...................................................................................+
{
    double ld_Price = 0.0;
//----
    if (Symb == "") {Symb = Symbol();}
    RefreshRates();
    switch (iPrice)
    {
        case 0:
            if (isTrade)
            {
                while (ld_Price == 0.0)
                {
                    if (Symb == Symbol()) {ld_Price = Bid;} else {ld_Price = MarketInfo (Symb, MODE_BID);}
                    if (!IsExpertEnabled() || IsStopped()) {break;}
                    Sleep (300); RefreshRates();
                }
            }
            else {if (Symb == Symbol()) {return (Bid);} else {return (MarketInfo (Symb, MODE_BID));}}
            break;
        case 1:
            if (isTrade)
            {
                while (ld_Price == 0.0)
                {
                    if (Symb == Symbol()) {ld_Price = Ask;} else {ld_Price = MarketInfo (Symb, MODE_ASK);}
                    if (!IsExpertEnabled() || IsStopped()) {break;}
                    Sleep (300); RefreshRates();
                }
            }
            else {if (Symb == Symbol()) {return (Ask);} else {return (MarketInfo (Symb, MODE_ASK));}}
            break;
    }
//----
    return (ld_Price);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheck_Decimal()
{
//----
    //----   5- 
    if (Digits % 2 == 1) {gi_Decimal = 10;}
    TakeProfit *= gi_Decimal;
    gd_TP = TakeProfit * Point;
    StopLoss *= gi_Decimal;
    gd_SL = StopLoss * Point;
    ProfitMIN *= gi_Decimal;
    Dopusk *= gi_Decimal;
    gd_dopusk = Dopusk * Point;
    Slippage *= gi_Decimal;
    gd_step = gi_Decimal * Point;
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          INT  ,  sDelimiter                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fStringToArray (
    string fs_String,
    int& fia_Array[],
    string fs_Delimiter = ",")
//+...................................................................................+
{
    string lsa_tmp[];
    int li_IND = StringSplit (fs_String, StringGetCharacter (fs_Delimiter, 0), lsa_tmp);
//----
    ArrayResize (fia_Array, li_IND);
    for (int i = 0; i < li_IND; i++)
    {fia_Array[i] = StringToInteger (lsa_tmp[i]);}
//----
    return (li_IND);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          DOUBLE  ,  sDelimiter                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fStringToArray (
    string fs_String,
    double& fda_Array[],
    bool fb_Point = false,
    string fs_Delimiter = ",")
//+...................................................................................+
{
    if (fs_Delimiter == ".") {Print ("fStringToArray():   - `.` !!!"); return (-1);}
    string lsa_tmp[];
    int li_IND = StringSplit (fs_String, StringGetCharacter (fs_Delimiter, 0), lsa_tmp);
//----
    ArrayResize (fda_Array, li_IND);
    for (int i = 0; i < li_IND; i++)
    {
        fda_Array[i] = StringToDouble (lsa_tmp[i]);
        if (fb_Point) fda_Array[i] *= (gi_Decimal * Point);
    }
//----
    return (li_IND);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      :   . aka KimIV,  http://www.kimiv.ru                          |
//+-----------------------------------------------------------------------------------+
//|     : 01.09.2005                                                            |
//|   :                                 |
//+-----------------------------------------------------------------------------------+
//|  :                                                                       |
//|    op -                                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_NameOP (int op) 
{
//----
    switch (op) 
    {
        case OP_BUY      : return ("BUY");
        case OP_SELL     : return ("SELL");
        case OP_BUYLIMIT : return ("BUYLIMIT");
        case OP_SELLLIMIT: return ("SELLLIMIT");
        case OP_BUYSTOP  : return ("BUYSTOP");
        case OP_SELLSTOP : return ("SELLSTOP");
    }
    return (StringConcatenate ("None (", op, ")"));
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_NameTF (int TF)
{
//----
    switch (TF)
    {
        case PERIOD_M1:  return ("M1");
		      case PERIOD_M5:  return ("M5");
		      case PERIOD_M15: return ("M15");
		      case PERIOD_M30: return ("M30");
		      case PERIOD_H1:  return ("H1");
		      case PERIOD_H4:  return ("H4");
		      case PERIOD_D1:  return ("D1");
		      case PERIOD_W1:  return ("W1");
		      case PERIOD_MN1: return ("MN1");
	   }
//----
	   return ("UnknownPeriod");
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|    : 27.10.2009                                                             |
//|  : fControlChangeValue_D                |
//|  double    (deviation)                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCCV_D (
    double param,
    int ix)
//+...................................................................................+
{
    static double cur_param[10];
    static bool   lb_first = true;
//---- 
    //----     
    if (lb_first)
    {
        for (int l_int = 0; l_int < ArraySize (cur_param); l_int++)
        {cur_param[l_int] = 0;}
        lb_first = false;
    }
    if (cur_param[ix] != param) {cur_param[ix] = param; return (true);}
//---- 
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_IsStatusTrade (
    bool& fb_PrintCom,         //      
    bool& fb_DrawObject,       //      
    bool& fb_InfoPrint,        //       ,   
    bool& fb_SoundAlert,       //      
    bool& fb_RealTrade)        //    /  
//+...................................................................................+
{
//----
    //----   GV-
    if (IsTesting()) {gs_NameGV = gs_NameGV + "_t";}
    if (IsDemo()) {gs_NameGV = gs_NameGV + "_d";}
    //----      
    if (IsTesting() || IsOptimization())
    {
        fb_RealTrade = False;
        //----        
        if (IsOptimization()) {fb_PrintCom = false;}
        if ((IsTesting() && !IsVisualMode()) || IsOptimization())
        {
            fb_DrawObject = false;
            gb_VirualTrade = true;
        }
        if (IsVisualMode())
        //----     
        {ArrayInitialize (gia_CommTime, TimeCurrent());}
        fb_SoundAlert = false;
    }
    //----   
    if (fb_PrintCom || fb_DrawObject) {fb_InfoPrint = true;}
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|        Magic                                                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fCheck_MyMagic (
    int fi_Magic,
    int& ar_Magic[])
//+...................................................................................+
{
//----
    for (int li_int = 0; li_int < ArraySize (ar_Magic); li_int++)
    {if (fi_Magic == ar_Magic[li_int]) {return (li_int);}}
//----
    return (-1);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|        ,    double  string c             |
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string DSDig (double v) {return (DoubleToStr (v, LotDecimal()));} 
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      :   . aka KimIV,  http://www.kimiv.ru                          |
//+-----------------------------------------------------------------------------------+
//|     : 01.02.2008                                                            |
//|   :        .             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string IIFs (bool condition, string ifTrue, string ifFalse)
{if (condition) {return (ifTrue);} else {return (ifFalse);}}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|  UNI:                 STRING                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void InitializeArray_STR (
    string& PrepareArray[],
    string Value = "")
//+...................................................................................+
{
    int l_int, size = ArraySize (PrepareArray);
//----
    for (l_int = 0; l_int < size; l_int++)
    {PrepareArray[l_int] = Value;}
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|  UNI:                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fRun_Sort (
    int& ar_INDEX[],
    double& fda_Value[])
//+...................................................................................+
{
    int li_IND, li_int, li_tmp, li_size = ArraySize (fda_Value);
//----
    for (li_IND = 0; li_IND < li_size; li_IND++)
    {ar_INDEX[li_IND] = li_IND;}
    for (li_IND = 0; li_IND < li_size; li_IND++)
    {
		      for (li_int = li_IND + 1; li_int < li_size; li_int++)
		      {
			         if (fda_Value[ar_INDEX[li_IND]] < fda_Value[ar_INDEX[li_int]])
			         {
				            li_tmp = ar_INDEX[li_int]; 
				            ar_INDEX[li_int] = ar_INDEX[li_IND]; 
				            ar_INDEX[li_IND] = li_tmp;
			         }
		      }
	   }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|  UNI:                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_NumPeriods (int fi_Period)
{
    static int lia_Periods[] = {1,5,15,30,60,240,1440,10080,43200};
//---- 
    for (int l_int = 0; l_int < ArraySize (lia_Periods); l_int++)
    {if (lia_Periods[l_int] == fi_Period) return (l_int);}
//---- 
    return (-1);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : Money Management                                                          |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                (  )        |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_SizeLot (
    string& fs_Info,                //  
    double fd_Lot,                  //   
    int fi_Type,                    //   
    double fd_BaseBalance,          //   + Pribul
    int fi_MG,                      // Magic
    int& fi_curOrdersInSeries,      //     
    int fi_MINMarginPercent,        //       %
    int fi_MAXZagruzkaDepoPercent,  //       %
    string fs_NameGV = "")          //  GV- 
//+...................................................................................+
{
    //----  MM   - 
    if (!UseMM) {return (fd_Lot);}
//----
    double ld_Lots, Money = 0;
    int    err = GetLastError();
//----
    switch (MeansType)
    {
        case 1: Money = gd_Balance; break;
        case 2: Money = gd_Equity; break;
        case 3: Money = gd_FreeMargin; break;
        case 4: Money = RiskDepo; break; 
        case 5: Money = fd_BaseBalance; break; 
    }                
    switch (LotsWayChoice)
    {
        case 0: ld_Lots = fd_Lot; break;
        case 1: //   MeansType
            if (MeansType == 3)
            {ld_Lots = (gd_FreeMargin * LotsPercent) / (MarketInfo (Symbol(), MODE_MARGINREQUIRED) * 100.0);}
            else {ld_Lots = Money * MathMin (AccountLeverage(), 100.0) * LotsPercent / (100000.0 * 100.0);}
            break;
    }
    //----  
    ld_Lots = fLotsNormalize (ld_Lots);
    if (ld_Lots < MinLot)
    {
        fs_Info = StringConcatenate (" [", DSDig (ld_Lots), "] < MinLot[", DSDig (MinLot), "] !!!");
        ld_Lots = MinLot;
    }
    ld_Lots = MathMin (ld_Lots, MaxLot);
    //---- 
//----
    return (ld_Lots);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fLotsNormalize (double fd_Lots)
{
//----
    fd_Lots -= gd_MINLOT;
    fd_Lots /= gd_LOTSTEP;
    fd_Lots = MathRound (fd_Lots);
    fd_Lots *= gd_LOTSTEP;
    fd_Lots += gd_MINLOT;
    fd_Lots = NormalizeDouble (fd_Lots, gi_dig);
    fd_Lots = MathMax (fd_Lots, gd_MINLOT);
    fd_Lots = MathMin (fd_Lots, gd_MAXLOT);
//----
    return (fd_Lots);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|   :  ,                          |
//+-----------------------------------------------------------------------------------+
//|  :                                                                       |
//|    ar_Price[]        : ar_Price[0] - Bid; ar_Price[1] - Ask                       |
//|    fi_VariantPrice   : 0 - Bid\Ask; 1 - Open[0]; 2 - Close [1]; 3 - Close[0]      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_MineTradePrice (
    int fi_VariantPrice,
    double& ar_Price[])
//+...................................................................................+
{
    double ld_Price;
    static datetime ldt_NewBar;
//----
    gd_RealSPREAD = MarketInfo (gs_Symbol, MODE_SPREAD) * Point;
    switch (fi_VariantPrice)
    {
        case 0: 
            RefreshRates();
            ld_Price = fGet_TradePrice (0, RealTrade, gs_Symbol);
            break;
        case 1: ld_Price = Open[0]; break;
        case 2: ld_Price = Close[1]; break;
        case 3: ld_Price = Close[0]; break;
        case 4: ld_Price = iOpen (gs_Symbol, gi_CTRL_TF, 0); break;
        case 5: 
            ar_Price[0] = iHigh (gs_Symbol, gi_CTRL_TF, 1);
            ar_Price[1] = iLow (gs_Symbol, gi_CTRL_TF, 1);
            return;
        case 6: 
            ar_Price[0] = iHigh (gs_Symbol, gi_CTRL_TF, 0);
            ar_Price[1] = iLow (gs_Symbol, gi_CTRL_TF, 0);
            return;
        case 7: 
            ar_Price[0] = iHigh (gs_Symbol, 1, 1);
            ar_Price[1] = iLow (gs_Symbol, 1, 1);
            return;
    }
    ar_Price[0] = ld_Price;
    ar_Price[1] = NormalizeDouble (ld_Price + gd_RealSPREAD, Digits);
    double ld_Ask = fGet_TradePrice (1, RealTrade, gs_Symbol);
    //----    Ask
    if ((gd_RealSPREAD == 0.0 || NormalizeDouble (ld_Ask - ar_Price[1], Digits) > 0.0) && RealTrade)
    {
        if (ldt_NewBar != gdt_BeginBar_H1)
        {
            Print ("Attention: Price[Bid] = ", DoubleToStr (ar_Price[0], Digits), 
            " | Price[Bid+spread] = ", DoubleToStr (ar_Price[1], Digits), " | Ask = ", DoubleToStr (ld_Ask, Digits),
            " | spread = ", DoubleToStr (gd_RealSPREAD / Point, 0));
            ldt_NewBar = gdt_BeginBar_H1;
        }
        if (ld_Ask > 0.0)
        {ar_Price[1] = ld_Ask;}
    }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          (  )                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fCalculate_Pribul (
    int& fi_HistoryOrders,       //        
    int fi_Magic = -1,           //  Magic
    int fi_OP = -1,              //  (BUY\SELL)  
    datetime fdt_TimeBegin = 0)  //  ,    
//+...................................................................................+
{
    int    err = GetLastError(), history_total = OrdersHistoryTotal();
    double ld_Pribul = 0.0, ld_ALLPribul = 0.0;
    string ls_Name;
//----
    //fCalculate_Pribul (gi_HistoryOrders, MG);
    fi_HistoryOrders = 0;
    for (int li_int = history_total - 1; li_int >= 0; li_int--)
    {
        if (OrderSelect (li_int, SELECT_BY_POS, MODE_HISTORY))
        {
            if (Symbol() == OrderSymbol())
            {
                if (OrderType() < 2 && (fi_OP < 0 || OrderType() == fi_OP))
                {
                    if (OrderMagicNumber() == fi_Magic || fi_Magic < 0)
                    {
                        if (fdt_TimeBegin < OrderCloseTime())
                        {
                            //----   
                            ld_Pribul = OrderProfit() + OrderSwap() + OrderCommission();
                            ld_ALLPribul += ld_Pribul;
                            fi_HistoryOrders++;
                            //----   GV-
                            if (li_int >= history_total - (cnt_MG + 5))
                            {
                                ls_Name = StringConcatenate (OrderTicket(), "_#SL");
                                if (GlobalVariableCheck (ls_Name))
                                {GlobalVariableDel (ls_Name);}
                            }
                        }
                        //----       
                        if (gb_first)
                        {
                            if (gdt_BeginTrade > OrderOpenTime())
                            {gdt_BeginTrade = OrderOpenTime();}
                        }
                    }
                }
            }
        }
    }
    //----   
    fGetLastError (gsa_Comment, "fCalculate_Pribul()", ind_ERR);
//----
    return (ld_ALLPribul);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_PipsValue()
{
    double ld_Price, ld_TickValue, ld_pips;
//----
    //----   
    if (OrderCloseTime() > 0) {ld_Price = OrderClosePrice();}
    else {if (OrderType() == OP_BUY) {ld_Price = Bid;} else {ld_Price = Ask;}}
    ld_pips = ((OrderOpenPrice() - ld_Price) / Point);
    if (ld_pips == 0) {return (1);}
    ld_TickValue = MathAbs (OrderProfit() / ld_pips);
    if (ld_TickValue == 0) {return (1);}
//----
    return (ld_TickValue);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        ,                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int LotDecimal()
{return (MathCeil (MathAbs (MathLog (MarketInfo (Symbol(), MODE_LOTSTEP)) / MathLog (10))));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fSplitField (string fs_Value)
{
    string ls_Begin = fs_Value, ls_End, ls_tmp;
    int    li_N1 = StringFind (ls_Begin, "."), li_Len;
//----
    //----        ( )
    if (li_N1 > 0)
    {
        li_N1 = MathMax (0, li_N1 - 3);
        ls_End = StringSubstr (ls_Begin, li_N1);
        if (li_N1 > 0) {ls_Begin = StringSubstr (ls_Begin, 0, li_N1);}
        else {return (fs_Value);}
    }
    li_Len = StringLen (ls_Begin);
    if (li_Len <= 0) {return (fs_Value);}
    while (li_Len > 3)
    {
        ls_tmp = StringSubstr (ls_Begin, li_Len - 3);
        ls_End = StringConcatenate (ls_tmp, " ", ls_End);
        ls_Begin = StringSubstr (ls_Begin, 0, li_Len - 3);
        li_Len = StringLen (ls_Begin);
    }
//----
    return (StringTrimLeft (StringConcatenate (ls_Begin, " ", ls_End)));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGetLastError (
    string& Comm_Array[],
    string Com = "",
    int index = -1)
//+...................................................................................+
{
    if (gb_VirualTrade) {return (0);}
//----
    int err = GetLastError();
//---- 
    if (err > 0)
    {
        string ls_err = StringConcatenate (Com, ":   ", err, ": ", ErrorDescription (err));
        Print (ls_err);
        if (index >= 0) {Comm_Array[index] = ls_err;}
    }
//---- 
    return (err);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCommentInChart (
    string& ar_Comment[],
    int& ar_ComTime[])
//+...................................................................................+
{
    static string lsa_Time[], lsa_Comment[], lsa_CommTime[], lsa_tmp[], ls_BeginTrade;
    static bool   lb_first = true;
    static int    li_size, li_size_CommTime, li_Period = 60;
    string ls_CTRL = "", ls_BLOCK_Comment, ls_Comment = "", ls_Statistic = "",
           ls_Error = "", ls_time = "", ls_sign,
           ls_row = "\n",
           ls_PSI = " PSITarasBY \n";
//----
    //----      
    if (lb_first)
    {
        li_Period *= gi_NewBarInPeriod;
        li_size = ArraySize (ar_Comment);
        ArrayResize (lsa_Time, li_size);
        ArrayResize (lsa_Comment, li_size);
        InitializeArray_STR (lsa_Comment);
        InitializeArray_STR (lsa_Time);
        li_size_CommTime = ArraySize (ar_ComTime);
        ArrayResize (lsa_CommTime, li_size_CommTime);
        ArrayResize (lsa_tmp, li_size_CommTime);
        InitializeArray_STR (lsa_CommTime);
        InitializeArray_STR (lsa_tmp);
        if (gdt_BeginTrade == 0) {gdt_BeginTrade = gdt_curTime;}
        ls_BeginTrade = StringConcatenate ("Begin Trade : ", TimeToStr (gdt_BeginTrade), "\n");
        lb_first = false;
    }
    //----  
    for (int li_MSG = 0; li_MSG < li_size; li_MSG++)
    {
        //----    
        if (StringLen (ar_Comment[li_MSG]) > 0)
        {
            if (ar_Comment[li_MSG] != lsa_Comment[li_MSG])
            {lsa_Comment[li_MSG] = ar_Comment[li_MSG];}
            if (li_MSG == li_size - 1) {ls_sign = "";} else {ls_sign = " : ";}
            lsa_Time[li_MSG] = StringConcatenate (TimeToStr (gdt_curTime), ls_sign);
            ar_Comment[li_MSG] = "";
        }
        //----   
        if (li_MSG < li_size - 1)
        {if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Comment = StringConcatenate (ls_Comment, lsa_Time[li_MSG], lsa_Comment[li_MSG], "\n");}}
        //----   
        else if (li_MSG == li_size - 1)
        {
            //----  2     
            if (gdt_curTime > StrToTime (lsa_Time[li_MSG]) + 7200)
            {lsa_Comment[li_MSG] = "";}
            if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Error = StringConcatenate ("ERROR:  ", lsa_Time[li_MSG], "\n", lsa_Comment[li_MSG], "\n", ls_row);}
        }
    }
    //----      
    if (gi_NewBarInPeriod >= 0) {ls_time = TimeToStr (gdt_NewBar + li_Period);}
    //----    
    ls_BLOCK_Comment = StringConcatenate (ExpertName, "\n", gs_Info, ls_time, "\n",
                 ls_BeginTrade,
                 ls_row,
                 //----  
                 ls_Comment,
                 ls_row,
                 //----   
                 "          PROFIT    = ", gs_sign, " ", fSplitField (DoubleToStr (gd_ProfitALL, 1)), "[", gi_MyOrders, "]\n",
                 "          RESULT    = ", gs_sign, " ", fSplitField (DoubleToStr (gd_PribulALL, 1)), "[", fSplitField (gi_HistoryOrders), "]\n",
                 ls_PSI,
                 //----  
                 ls_Error);
    //----      
    Comment (ls_BLOCK_Comment);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fPrepareComment (string sText = "", bool bConditions = false)
{if (bConditions) {return (sText);} return ("");}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fPrintAndShowComment (
    string& Text,
    bool Show_Conditions,
    bool Print_Conditions,
    string& s_Show[],
    int ind = -1)
//+...................................................................................+
{
    if ((Show_Conditions || Print_Conditions))
    {
        if (StringLen (Text) > 0)
        {
            if (ind >= 0 && Show_Conditions) {s_Show[ind] = Text;}
            if (Print_Conditions) {Print (Text);}
        }
    }
    //----  
    Text = "";
//---- 
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheckInfo()
{
    static double ld_pre_Lot = 0;
//----
    if (ShowCommentInChart)
    {
        if (ld_pre_Lot != LotsMM)
        {
            string ls_Trail = "", ls_MM, ls_addConditions;
            ls_MM = IIFs (UseMM, StringConcatenate ("MM (", DSDig (LotsMM), IIFs ((LotsWayChoice == 2), StringConcatenate ("/", gi_curOrdersInSeries), ""), ")", fGet_MeansType (MeansType, LotsPercent)), "L: " + DSDig (LotsMM));
            ls_addConditions = StringConcatenate (IIFs ((StringLen (ls_Trail) > 0), ls_Trail, ""),
            IIFs ((StringLen (ls_MM) > 0), " - ", ""),
            IIFs ((StringLen (ls_MM) > 0), ls_MM, ""));
            //----  " - "    ( )
            ls_addConditions = IIFs ((StringFind (ls_addConditions, " - ") == 0), StringSubstr (ls_addConditions, 3), ls_addConditions);
            //----   
            gs_Info = StringConcatenate (gs_NameGV, ":     STOP`s", " (", StopLoss, "/", TakeProfit, ")", "\n",
            IIFs ((StringLen (ls_addConditions) > 0), StringConcatenate (ls_addConditions, "\n"), ""),
            "Lots: MIN = ", DSDig (gd_MINLOT), " | MAX = ", DSDig (gd_MAXLOT), " | STEP = ", gd_LOTSTEP, "\n",
            IIFs ((gi_NewBarInPeriod < 0), "   ", " : "));
            ld_pre_Lot = LotsMM;
        }
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_MeansType (
    int fi_Variant,
    int fi_Percent)
//+...................................................................................+
{
    string ls_Percent = "";
//----
    if (LotsWayChoice == 1 || LotsWayChoice == 2)
    {
        ls_Percent = StringConcatenate (fi_Percent, "% ");
        switch (fi_Variant)
        {
            case 1: return (StringConcatenate (": ", ls_Percent, "from Balance = ", gs_sign, fSplitField (DoubleToStr (gd_Balance, 1))));
            case 2: return (StringConcatenate (": ", ls_Percent, "from Equity = ", gs_sign, fSplitField (DoubleToStr (gd_Equity, 1))));
            case 3: return (StringConcatenate (": ", ls_Percent, "from FreeMargin = ", gs_sign, fSplitField (DoubleToStr (gd_FreeMargin, 1))));
            case 4: return (StringConcatenate (": ", ls_Percent, "from RiskDepo = ", gs_sign, fSplitField (DoubleToStr (RiskDepo, 1))));
            case 5: return (StringConcatenate (": ", ls_Percent, "from BaseBalance = ", gs_sign, fSplitField (DoubleToStr (gd_BaseBalance, 1))));
        }
    }
//----
    return ("");
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_Statistic()
{
    int err = GetLastError();
//----
    gd_Balance = AccountBalance();
    gd_Equity = AccountEquity();
    gd_FreeMargin = AccountFreeMargin();
    gd_Margin = AccountMargin();
    //----    " "
    gdt_curTime = TimeCurrent();
    if (fCCV_D (OrdersHistoryTotal(), 3))
    {
        //----     
        gd_PribulALL = 0.0;
        double ld_Pribul = 0.0;
        int li_tmp_HistoryOrders = 0;
        gi_HistoryOrders = 0;
        ArrayInitialize (gia_HistoryOrders, 0);
        for (int li_MG = 0; li_MG < cnt_MG; li_MG++)
        {
            ld_Pribul = fCalculate_Pribul (li_tmp_HistoryOrders, gia_MG[li_MG]);
            gda_Pribul[li_MG] = ld_Pribul;
            gd_PribulALL += ld_Pribul;
            gi_HistoryOrders += li_tmp_HistoryOrders;
            gia_HistoryOrders[li_MG] += li_tmp_HistoryOrders;
            gda_BaseBalance[li_MG] = BaseBalance + ld_Pribul;
        }
        gd_BaseBalance = BaseBalance + gd_PribulALL;
        //----     ,   
        if (Use_Prioritity) {fRun_Sort (gia_Priority, gda_Pribul);}
    }
    //----    
    gd_MAXBalance = MathMax (gd_MAXBalance, gd_Balance);
    //----        
    fCheckInfo();
    //----   
    fGetLastError (gsa_Comment, "fGet_Statistic()", ind_ERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ,                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool IsTradeTime (
    int OpenHour,
    int CloseHour)
//+...................................................................................+
{
    if (!TimeControl) {return (true);}
//----
    int li_Hour = TimeHour (gdt_curTime);
//----
    if (OpenHour < CloseHour && (li_Hour < OpenHour || li_Hour >= CloseHour))
    {return (FALSE);}
    if (OpenHour > CloseHour && (li_Hour < OpenHour && li_Hour >= CloseHour))
    {return (FALSE);}
    if (OpenHour == 0) {CloseHour = 24;}
    if (li_Hour == CloseHour - 1 && TimeMinute (gdt_curTime) >= 45)
    {return (FALSE);}
//----
    return (TRUE);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ,  "  "                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool IsBadTime (
    int& ar_BadDay[],
    int& ar_BadTime[])
//+...................................................................................+
{
//----
    if (!TimeControl) {return (false);}
    for (int li_DAY = 0; li_DAY < ArraySize (ar_BadDay); li_DAY++)
    {
        if (TimeDayOfWeek (gdt_curTime) == ar_BadDay[li_DAY])
        {return (TRUE);}
    }
    for (int li_HOUR = 0; li_HOUR < ArraySize (ar_BadTime); li_HOUR++)
    {
        if (TimeHour (gdt_curTime) == ar_BadTime[li_HOUR])
        {return (TRUE);}
    }
//----
    return (FALSE);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : TESTER                                                                    |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           ""                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Continue()
{
    static bool lb_Continue = true;
//----
    if (!RealTrade)
    {
        //----     ()
        if (gi_NewBarInPeriod > 0) if (iTime (gs_Symbol, gi_NewBarInPeriod, 0) == 0) {fPrintAlert (gi_NewBarInPeriod, 0); return (true);}
        if (iTime (gs_Symbol, gi_ControlPeriod, 0) == 0) {fPrintAlert (gi_ControlPeriod, 1); return (true);}
    }
    //----     
    if (!lb_Continue) return (false);
    if (IsOptimization())
    {
        if (fGet_NumPeriods (gi_ControlPeriod) < 0) {return (true);}
        if (fGet_NumPeriods (gi_NewBarInPeriod) < 0) {return (true);}
    }
    lb_Continue = false;
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fPrintAlert (
    int fi_TF,                     // 
    int fi_IND)                    //    
//+...................................................................................+
{
    static int lia_Minute[2] = {0,0};
//----
    if (lia_Minute[fi_IND] != TimeMinute (TimeCurrent()))
    {
        lia_Minute[fi_IND] = TimeMinute (TimeCurrent());
        Print (gs_Symbol, ":    ", fGet_NameTF (fi_TF), " : ", TimeToStr (TimeCurrent()));
    }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
